function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/* eslint-disable no-param-reassign */
import * as React from 'react';
import raf from "rc-util/es/raf";
export default function useScrollTo(containerRef, data, height, heights, itemHeight, getKey) {
  var scrollRef = React.useRef();
  return function (arg) {
    raf.cancel(scrollRef.current);

    if (typeof arg === 'number') {
      containerRef.current.scrollTop = arg;
    } else if (arg && _typeof(arg) === 'object') {
      var index;
      var align = arg.align;

      if ('index' in arg) {
        index = arg.index;
      } else {
        index = data.findIndex(function (item) {
          return getKey(item) === arg.key;
        });
      } // We will retry 3 times in case dynamic height shaking


      var syncScroll = function syncScroll() {
        var times = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 3;
        if (times < 0) return;
        scrollRef.current = raf(function () {
          if (!containerRef.current) return; // Get top & bottom

          var stackTop = 0;
          var itemTop = 0;
          var itemBottom = 0;

          for (var i = 0; i <= index; i += 1) {
            var key = getKey(data[i]);
            itemTop = stackTop;
            var cacheHeight = heights.get(key);
            itemBottom = itemTop + (cacheHeight === undefined ? itemHeight : cacheHeight);
            stackTop = itemBottom;
          } // Scroll to


          switch (align) {
            case 'top':
              containerRef.current.scrollTop = itemTop;
              break;

            case 'bottom':
              containerRef.current.scrollTop = itemBottom - height;
              break;

            default:
              {
                var scrollTop = containerRef.current.scrollTop;
                var scrollBottom = scrollTop + height;

                if (itemTop < scrollTop) {
                  containerRef.current.scrollTop = itemTop;
                } else if (itemBottom > scrollBottom) {
                  containerRef.current.scrollTop = itemBottom - height;
                }
              }
          }

          syncScroll(times - 1);
        });
      };

      syncScroll();
    }
  };
}